package be.iminds.ilabt.jfed.experimenter_gui.tasks;

import be.iminds.ilabt.jfed.experimenter_gui.editor.EditableRspec;
import be.iminds.ilabt.jfed.experimenter_gui.events.OpenESpecEvent;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.highlevel.tasks.RecoverSliceTask;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.AggregateManagerWrapper;
import be.iminds.ilabt.jfed.util.common.GeniUrn;
import javafx.concurrent.Task;
import javafx.stage.Window;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

/**
 * User: twalcari
 * Date: 1/28/2015
 * Time: 10:12
 */
public interface TasksFactory {
    @Nonnull RecoverSliceTask createRecoverSliceTask(@Nonnull GeniUrn sliceUrn);

    @Nonnull RecoverSliceTask createRecoverSliceTask(@Nonnull Slice slice);

    @Nonnull DeleteDiskImageTask createDeleteDiskImageTask(@Nonnull Server auth, @Nonnull AggregateManagerWrapper.ImageInfo imageInfo);

    @Nonnull OpenRequestRspecTask createOpenRequestRspecTask(@Nullable Window parentWindow, @Nonnull File file) throws FileNotFoundException;

    @Nonnull OpenRequestRspecTask createOpenRequestRspecTask(@Nullable Window parentWindow, @Nonnull InputStream inputStream, long fileLength, @Nonnull String name, @Nullable File defaultSaveFile);

    @Nonnull Task<EditableRspec> createOpenRequestRspecTaskFromString(@Nullable Window parentWindow, @Nonnull String requestRspecString);

    @Nonnull OpenRequestRspecTask createOpenRequestRspecTaskFromUrl(@Nullable Window parentWindow, @Nonnull String urlString) throws IOException;

    @Nonnull FetchAllSlicesInfoTask createFetchAllSlicesInfoTask();

    @Nonnull OpenTutorialTask createOpenTutorialTask(@Nullable Window dialogOwnerWindow, @Nonnull String urlString) throws IOException;

    @Nonnull OpenESpecTask createOpenESpecTask(@Nullable Window dialogOwnerWindow, @Nonnull OpenESpecEvent event) throws IOException;
}
